function ShockCooldown_OnLoad(self)
self:RegisterEvent("ADDON_LOADED");
self:RegisterEvent("SPELL_UPDATE_COOLDOWN");
self:RegisterEvent("CHARACTER_POINTS_CHANGED");
SLASH_SHOCKCOOLDOWN1 = "/shock";
SLASH_SHOCKCOOLDOWN2 = "/scd";
SlashCmdList["SHOCKCOOLDOWN"] = ShockCooldown_CMD;
end

function ShockCooldown_OnEvent(self, event, ...)

if ( event == "ADDON_LOADED" ) then
	local addon = select(1, ...);
	if ( addon == "ShockCooldown" ) then
		if not shock_debug then
			shock_debug = 0;
		end
		if (GetLocale() == "deDE") then
			if not shock_standby then
				if not GetSpellInfo(GetSpellInfo(403)) then
					shock_standby = 1;
					DEFAULT_CHAT_FRAME:AddMessage("Dein Charakter ist kein Schamane. ShockCooldown befindet sich daher im Standbymodus.")
				else
					shock_standby = 0;
				end
			end
			DEFAULT_CHAT_FRAME:AddMessage("ShockCooldown 2.0 wurde erfolgreich geladen!")
			if (shock_debug == 1) then
				ShockCooldownFrame:AddMessage("ShockCooldown Debug: Frametest - Wenn du das siehst, existiert der Frame.",0,1.0,0)
			end
		else
			if not shock_standby then	
				if not GetSpellInfo(GetSpellInfo(403)) then
					shock_standby = 1;
					DEFAULT_CHAT_FRAME:AddMessage("Your char is not a Shaman. Thus, ShockCooldown defaults to standby mode.")
				else
					shock_standby = 0;
				end
			end
			DEFAULT_CHAT_FRAME:AddMessage("ShockCooldown 2.0 - Loaded Successfully")
			if (shock_debug == 1) then
				ShockCooldownFrame:AddMessage("ShockCooldown Debug: Testing Frame - If you see this, the frame exists.",0,1.0,0)
			end
		end
		if GetSpellInfo(GetSpellInfo(16116)) then
			local revebrank = 5;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 5 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 5 Detected!")
				end
			end
		elseif GetSpellInfo(GetSpellInfo(16115)) then
			local revebrank = 4;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 4 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 4 Detected!")
				end
			end
		elseif GetSpellInfo(GetSpellInfo(16114)) then
			local revebrank = 3;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 3 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 3 Detected!")
				end
			end
		elseif GetSpellInfo(GetSpellInfo(16113)) then
			local revebrank = 2;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 2 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 2 Detected!")
				end
			end
		elseif GetSpellInfo(GetSpellInfo(16040)) then
			local revebrank = 1;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 1 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 1 Detected!")
				end
			end
		else
			local revebrank = 0;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen nicht vorhanden!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation not learned!")
				end
			end
		end
		if revebrank then
			local cdreduction = math.floor(revebrank * 0.2)
		end
	end
elseif ( event == "SPELL_UPDATE_COOLDOWN") then
	if (shock_standby == 0) then
	local frostshockname = GetSpellInfo(8042);
	local start, duration, enabled = GetSpellCooldown(frostshockname)
	local lightningname = GetSpellInfo(403);
	local start2, duration2, enabled2 = GetSpellCooldown(lightningname)
	if duration == 0 then
		return;
	else
		if duration == duration2 then
			return;
		else
			if not cdreduction then
				local AceTimer = LibStub("AceTimer-3.0");
				AceTimer:ScheduleTimer(ShockCooldown_CooldownUp, 6);
			else
				local shockcd = math.floor(6 - cdreduction);
				local AceTimer = LibStub("AceTimer-3.0");
				AceTimer:ScheduleTimer(ShockCooldown_CooldownUp, shockcd);
			end
		end
	end
	end
elseif ( event == "CHARACTER_POINTS_CHANGED") then
	if (shock_standby == 0) then
	local talentchangepoints = select(1, ...);
	if ( talentchangepoints == -1 ) then
		if GetSpellInfo(GetSpellInfo(16116)) then
			local revebrank = 5;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 5 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 5 Detected!")
				end
			end
		elseif GetSpellInfo(GetSpellInfo(16115)) then
			local revebrank = 4;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 4 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 4 Detected!")
				end
			end
		elseif GetSpellInfo(GetSpellInfo(16114)) then
			local revebrank = 3;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 3 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 3 Detected!")
				end
			end
		elseif GetSpellInfo(GetSpellInfo(16113)) then
			local revebrank = 2;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 2 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 2 Detected!")
				end
			end
		elseif GetSpellInfo(GetSpellInfo(16040)) then
			local revebrank = 1;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen Rang 1 erkannt!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation Rank 1 Detected!")
				end
			end
		else
			local revebrank = 0;
			if (shock_debug == 1) then
				if (GetLocale() == "deDE") then
					DEFAULT_CHAT_FRAME:AddMessage("Nachklingen nicht vorhanden!")
				else
					DEFAULT_CHAT_FRAME:AddMessage("Reverberation not learned!")
				end
			end
		end
		if revebrank then
			local cdreduction = math.floor(revebrank * 0.2)
		end		
	end
	end
end
end

function ShockCooldown_CooldownUp()
	if (shock_standby == 0) then
		ShockCooldownFrame:SetFont("MORPHEUS.TTF",28,"OUTLINE, MONOCHROME")
		if (GetLocale() == "deDE") then
			ShockCooldownFrame:AddMessage("Schocks bereit!",0,1.0,0)
		else
			ShockCooldownFrame:AddMessage("Shocks ready!",0,1.0,0)
		end
	end
end

function ShockCooldown_CMD(cmd)
	if (GetLocale() == "deDE") then
		if not cmd then
			DEFAULT_CHAT_FRAME:AddMessage("ShockCooldown 2.0")
			DEFAULT_CHAT_FRAME:AddMessage("Verwendung:")
			DEFAULT_CHAT_FRAME:AddMessage("/shock debug - Zeigt die Debughilfe an")
			DEFAULT_CHAT_FRAME:AddMessage("/shock standby - Stoppt/Reaktiviert das Addon")
		elseif (cmd == "debug toggle") then
			if not shock_debug then
				shock_debug = 0;
			end
			if (shock_debug == 1) then
				shock_debug = 0;
				DEFAULT_CHAT_FRAME:AddMessage("Debugnachrichten DEAKTIVIERT")
			else
				shock_debug = 1;
				DEFAULT_CHAT_FRAME:AddMessage("Debugnachrichten AKTIVIERT")
			end
		elseif (cmd == "debug test") then
			ShockCooldown_CooldownUp();
		elseif (cmd == "debug") then
			if not shock_standby then
				shock_standby = 0;
			end
			if (shock_standby == 0) then
				DEFAULT_CHAT_FRAME:AddMessage("ShockCooldown 2.0 Debug")
				DEFAULT_CHAT_FRAME:AddMessage("Verwendung:")
				DEFAULT_CHAT_FRAME:AddMessage("/shock debug toggle - Aktiviert/Deaktiviert Debugnachrichten")
				DEFAULT_CHAT_FRAME:AddMessage("/shock debug test - Testet die Funktion, die beim Ablaufen des Cooldowns gestartet wird")
			else
				DEFAULT_CHAT_FRAME:AddMessage("Debugging ist im Standbymodus nicht abrufbar.")
			end
		elseif (cmd == "standby") then
			if not shock_standby then
				shock_standby = 0;
			end
			if  (shock_standby == 0) then
				shock_standby = 1;
				DEFAULT_CHAT_FRAME:AddMessage("Standbymodus AKTIVIERT")
			else
				shock_standby = 0;
				DEFAULT_CHAT_FRAME:AddMessage("Standbymodus DEAKTIVIERT")
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("ShockCooldown 2.0")
			DEFAULT_CHAT_FRAME:AddMessage(cmd .. " ist keine Option von /shock.")
			DEFAULT_CHAT_FRAME:AddMessage("Verwendung:")
			DEFAULT_CHAT_FRAME:AddMessage("/shock debug - Zeigt die Debughilfe an")
			DEFAULT_CHAT_FRAME:AddMessage("/shock standby - Stoppt/Reaktiviert das Addon")
		end
	else
		if not cmd then
			DEFAULT_CHAT_FRAME:AddMessage("ShockCooldown 2.0")
			DEFAULT_CHAT_FRAME:AddMessage("Usage:")
			DEFAULT_CHAT_FRAME:AddMessage("/shock debug - Shows Debug Help")
			DEFAULT_CHAT_FRAME:AddMessage("/shock standby - Toggles Standby Mode")
		elseif (cmd == "debug toggle") then
			if not shock_debug then
				shock_debug = 0;
			end
			if (shock_debug == 1) then
				shock_debug = 0;
				DEFAULT_CHAT_FRAME:AddMessage("Debug Messages Turned OFF")
			else
				shock_debug = 1;
				DEFAULT_CHAT_FRAME:AddMessage("Debug Messages Turned ON")
			end
		elseif (cmd == "debug test") then
			ShockCooldown_CooldownUp();
		elseif (cmd == "debug") then
			if not shock_standby then
				shock_standby = 0;
			end
			if (shock_standby == 0) then
				DEFAULT_CHAT_FRAME:AddMessage("ShockCooldown 2.0 Debug")
				DEFAULT_CHAT_FRAME:AddMessage("Verwendung:")
				DEFAULT_CHAT_FRAME:AddMessage("/shock debug toggle - Toggles Debug Messages")
				DEFAULT_CHAT_FRAME:AddMessage("/shock debug test - Tests the ''Cooldown is Up'' function")
			else
				DEFAULT_CHAT_FRAME:AddMessage("Debugging is not aviable in standby mode")
			end
		elseif (cmd == "standby") then
			if not shock_standby then
				shock_standby = 0;
			end
			if (shock_standby == 1) then
				shock_standby = 0;
				DEFAULT_CHAT_FRAME:AddMessage("Standby mode is now OFF")
			else
				shock_standby = 1;
				DEFAULT_CHAT_FRAME:AddMessage("Standby mode is now ON")
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("ShockCooldown 2.0")
			DEFAULT_CHAT_FRAME:AddMessage(cmd .. " is no viable option for /shock")
			DEFAULT_CHAT_FRAME:AddMessage("Usage:")
			DEFAULT_CHAT_FRAME:AddMessage("/shock debug - Shows Debug Help")
			DEFAULT_CHAT_FRAME:AddMessage("/shock standby - Toggles Standby Mode")
		end
	end
end